
public abstract class BankAccount {

	protected int accNum;
	protected double balance;
	protected static int serialNum = 0;
	
	/** Default constructor 
	 * 
	 */
	public BankAccount()
	{
		balance = 0.0;
		accNum = ++serialNum;
	}
	
	/** Overloaded constructor
	 *  
	 */
	public BankAccount( double startBalance) throws Exception
	{
		deposit(balance);
		accNum = ++serialNum;
	}
	
	/** accessor for balance
	 * 
	 */
	public double getBalance()
	{
		return balance;
	}
	
	/* accessor for account number
	 * 
	 */
	public int getAccNum()
	{
		return accNum;
	}
	
	/** Deposit amount to account
	 * 
	 */
	public void deposit( double amount ) throws Exception
	{
		if(amount >= 0.0 )
			balance += amount;
		
		else
			throw new Exception("Illegal Amount");
	}
	
	/** withdraw amount from account
	 * 
	 */
	public void withdraw( double amount ) throws Exception
	{
		if(amount >= 0.0 && amount <= balance)
			balance -= amount;
		
		else
			throw new Exception("Insufficient Balance");
	}
	
	public String toString()
	{
		return "The balance is of the " + accType() + " " + getAccNum() + " is " + balance;
	}
	
	public abstract void applyComputation();
	public abstract String accType();
}
